open Traffic_Lights
open Intersections

fact No_stops_in_any_direction {
    all t: Time - first |
        all i: Intersection |
            all d: i.connections.Intersection | 
                i.connections[d].lights[OppositeDirection.reverse[d]].color.(t.prev) = green =>
                    some i.connections[OppositeDirection.reverse[d]] =>
                        i.lights[OppositeDirection.reverse[d]].color.t = green
}

// At each time, at each intersection,
// at least one traffic light changes color
fact Constantly_changing_lights {
    all t: Time - first | 
        all i: Intersection |
            some d: Direction |
                i.lights[d].color.(t.prev) != i.lights[d].color.t
}

// For all traffic lights, if the light changes color then the change  
// conforms to the color sequencing in Color_Sequence
fact Lights_change_color_in_the_proper_sequence {
    all t: Time - first | 
        all light: Traffic_Light |  
            light.color.(t.prev) != light.color.t => 
               light.color.t = Color_Sequence.sequence[light.color.(t.prev)]
}

// At each intersection there is 
// exactly one traffic light that is not red
fact Exactly_one_non_red_light {
    all t: Time |
        all i: Intersection |
            no disj d, d': Direction | 
               //(i.lights[d].color.t in (green + yellow)) and  (i.lights[d'].color.t in (green + yellow))
               ((i.lights[d].color.t = green) or (i.lights[d].color.t = yellow)) and
               ((i.lights[d'].color.t = green) or (i.lights[d'].color.t = yellow))
}

run {} for 10


