open Traffic_Lights

abstract sig Direction {}
one sig north extends Direction {}
one sig south extends Direction {}
one sig west extends Direction {}
one sig east extends Direction {}

one sig OppositeDirection {
    reverse: Direction -> Direction
} {
    reverse = north -> south +
                      south -> north +
                      west -> east +
                      east -> west
}

abstract sig Intersection {
    connections: Direction lone -> lone Intersection,
    lights: Direction lone -> lone Traffic_Light
}
one sig Intersection0 extends Intersection {} {
    connections = north -> Intersection1 +
                                west -> Intersection3
    lights = north -> Traffic_Light0 +
                   west ->Traffic_Light1
}
one sig Intersection1 extends Intersection {} {
    connections = north -> Intersection2 +
                                south -> Intersection0 + 
                                west -> Intersection4 
    lights = north -> Traffic_Light2 +
                   south -> Traffic_Light3 +
                   west -> Traffic_Light4
}
one sig Intersection2 extends Intersection {} {
    connections = south -> Intersection1 + 
                                west -> Intersection5 
    lights = south -> Traffic_Light5 +
                   west -> Traffic_Light6
}
one sig Intersection3 extends Intersection {} {
    connections = north -> Intersection4 + 
                                east -> Intersection0 +
                                west -> Intersection6 
    lights = north -> Traffic_Light7 +
                   east -> Traffic_Light8 +
                   west -> Traffic_Light9
}
one sig Intersection4 extends Intersection {} {
    connections = north -> Intersection5 + 
                                south -> Intersection3 + 
                                east -> Intersection1 +
                                west -> Intersection7 
    lights = north -> Traffic_Light10 +
                   south -> Traffic_Light11 +
                   east -> Traffic_Light12 +
                   west -> Traffic_Light13
}
one sig Intersection5 extends Intersection {} {
    connections = south -> Intersection4 + 
                                east -> Intersection2 +
                                west -> Intersection8 
    lights = south -> Traffic_Light14 +
                   east -> Traffic_Light15 +
                   west -> Traffic_Light16 
}
one sig Intersection6 extends Intersection {} {
    connections = north -> Intersection7 +
                                east -> Intersection3  
    lights = north -> Traffic_Light17 +
                   east -> Traffic_Light18
}
one sig Intersection7 extends Intersection {} {
    connections = north -> Intersection8 + 
                                south -> Intersection6 + 
                                east -> Intersection4
    lights = north -> Traffic_Light19+
                   south -> Traffic_Light20 +
                   east -> Traffic_Light21
}
one sig Intersection8 extends Intersection {} {
    connections = south -> Intersection7 + 
                                east -> Intersection5 
    lights = south -> Traffic_Light22+
                   east -> Traffic_Light23
}

run {}

assert If_intersection_A_connects_to_B_then_B_connects_to_A {
    all i: Intersection |
        all d: i.connections.Intersection |
            i.connections[d].connections[OppositeDirection.reverse[d]] = i
                    
}
check If_intersection_A_connects_to_B_then_B_connects_to_A 

assert If_intersection_A_connects_to_B_then_B_has_a_light_facing_to_A {
    all i: Intersection |
        all d: i.connections.Intersection |
            some i.connections[d].lights[OppositeDirection.reverse[d]] 
                    
}
check  If_intersection_A_connects_to_B_then_B_has_a_light_facing_to_A 

assert If_A_connects_in_direction_d_then_A_has_a_light_in_direction_d {
    all i: Intersection |
        all d: i.connections.Intersection |
            some i.lights[d] 
}
check If_A_connects_in_direction_d_then_A_has_a_light_in_direction_d

assert All_Traffic_Lights_used {
    Intersection.lights[Direction] = Traffic_Light
}
check All_Traffic_Lights_used

assert All_Traffic_Lights_used_once {
    all t: Traffic_Light | 
        #lights.t = 1
}
check All_Traffic_Lights_used_once
