open Traffic_Lights

abstract sig Direction {}
one sig north extends Direction {}
one sig south extends Direction {}
one sig west extends Direction {}
one sig east extends Direction {}

one sig OppositeDirection {
    reverse: Direction -> Direction
} {
    reverse = north -> south +
                      south -> north +
                      west -> east +
                      east -> west
}

abstract sig Intersection {
    connections: Direction lone -> lone Intersection,
    lights: Direction lone -> lone Traffic_Light
}
one sig Intersection0 extends Intersection {} {
    connections = north -> Intersection1 +
                                west -> Intersection4
    lights = north -> Traffic_Light0 +
                   west ->Traffic_Light1
}
one sig Intersection1 extends Intersection {} {
    connections = north -> Intersection2 +
                                south -> Intersection0 + 
                                west -> Intersection5 
    lights = north -> Traffic_Light2 +
                   south -> Traffic_Light4 +
                   west -> Traffic_Light3
}
one sig Intersection2 extends Intersection {} {
    connections = north -> Intersection3 +
                                south -> Intersection1 + 
                                west -> Intersection6 
    lights = north -> Traffic_Light5 +
                   south -> Traffic_Light7 +
                   west -> Traffic_Light6
}
one sig Intersection3 extends Intersection {} {
    connections = west -> Intersection7 +
                                south -> Intersection2 
    lights = west -> Traffic_Light8 +
                   south -> Traffic_Light9
}
one sig Intersection4 extends Intersection {} {
    connections = north -> Intersection5 + 
                                east -> Intersection0 +
                                west -> Intersection8 
    lights = north -> Traffic_Light10 +
                   east -> Traffic_Light12 +
                   west -> Traffic_Light11
}
one sig Intersection5 extends Intersection {} {
    connections = north -> Intersection6 +
                                south -> Intersection4 + 
                                east -> Intersection1 +
                                west -> Intersection9  
    lights = north -> Traffic_Light13 +
                   south -> Traffic_Light15 +
                   east -> Traffic_Light16 +
                   west -> Traffic_Light14
}
one sig Intersection6 extends Intersection {} {
    connections = north -> Intersection7 +
                                south -> Intersection5 + 
                                east -> Intersection2+
                                west -> Intersection10 
    lights = north -> Traffic_Light17 +
                   south -> Traffic_Light19 +
                   east -> Traffic_Light20 +
                   west -> Traffic_Light18
}
one sig Intersection7 extends Intersection {} {
    connections = south -> Intersection6 + 
                                east -> Intersection3+
                                west -> Intersection11
    lights = south -> Traffic_Light22 +
                   east -> Traffic_Light23 +
                   west -> Traffic_Light21
}
one sig Intersection8 extends Intersection {} {
    connections = north -> Intersection9 + 
                                east -> Intersection4 +
                                west -> Intersection12 
    lights = north -> Traffic_Light24 +
                   east -> Traffic_Light26 +
                   west -> Traffic_Light25
}
one sig Intersection9 extends Intersection {} {
    connections = north -> Intersection10 +
                                south -> Intersection8+ 
                                east -> Intersection5 +
                                west -> Intersection13 
    lights = north -> Traffic_Light27 +
                   south -> Traffic_Light29 +
                   east -> Traffic_Light30 +
                   west -> Traffic_Light28
}
one sig Intersection10 extends Intersection {} {
    connections = north -> Intersection11 +
                                south -> Intersection9 + 
                                east -> Intersection6 +
                                west -> Intersection14 
    lights = north -> Traffic_Light31 +
                   south -> Traffic_Light33 +
                   east -> Traffic_Light34 +
                   west -> Traffic_Light32
}
one sig Intersection11 extends Intersection {} {
    connections = south -> Intersection10 + 
                                east -> Intersection7 +
                                west -> Intersection15  
    lights = south -> Traffic_Light36 +
                   east -> Traffic_Light37 +
                   west -> Traffic_Light35
}
one sig Intersection12 extends Intersection {} {
    connections = north -> Intersection13 + 
                                east -> Intersection8 
    lights = north -> Traffic_Light38 +
                   east -> Traffic_Light39
}
one sig Intersection13 extends Intersection {} {
    connections = north -> Intersection14 + 
                                south-> Intersection12 +
                                east -> Intersection9 
    lights = north -> Traffic_Light40 +
                   south -> Traffic_Light41 +
                   east -> Traffic_Light42
}
one sig Intersection14 extends Intersection {} {
    connections = north -> Intersection15+ 
                                south-> Intersection13 +
                                east -> Intersection10 
    lights = north -> Traffic_Light43 +
                   south -> Traffic_Light44 +
                   east -> Traffic_Light45
}
one sig Intersection15 extends Intersection {} {
    connections = south -> Intersection14 + 
                                east -> Intersection11
    lights = south -> Traffic_Light46 +
                   east -> Traffic_Light47
}

run {}

assert If_intersection_A_connects_to_B_then_B_connects_to_A {
    all i: Intersection |
        all d: i.connections.Intersection |
            i.connections[d].connections[OppositeDirection.reverse[d]] = i
                    
}
check If_intersection_A_connects_to_B_then_B_connects_to_A 

assert If_intersection_A_connects_to_B_then_B_has_a_light_facing_to_A {
    all i: Intersection |
        all d: i.connections.Intersection |
            some i.connections[d].lights[OppositeDirection.reverse[d]] 
                    
}
check  If_intersection_A_connects_to_B_then_B_has_a_light_facing_to_A 

assert If_A_connects_in_direction_d_then_A_has_a_light_in_direction_d {
    all i: Intersection |
        all d: i.connections.Intersection |
            some i.lights[d] 
}
check If_A_connects_in_direction_d_then_A_has_a_light_in_direction_d

assert All_Traffic_Lights_used {
    Intersection.lights[Direction] = Traffic_Light
}
check All_Traffic_Lights_used

assert All_Traffic_Lights_used_once {
    all t: Traffic_Light | 
        #lights.t = 1
}
check All_Traffic_Lights_used_once
