module Antisymmetric

open Inverse
open Complement
open Common

/***************************
     ANTISYMMETRIC PROPERTY
****************************/

// Given a set A and a relation R in A, R is anti-symmetric 
// if whenever both (x, y) and (x, y) are in R, then x = y.

sig A {}

one sig Test {
    R: A -> A
} {
    A.(R - (A <: iden)) & (R - (A <: iden)).A = none  // Constrain R to be anti-symmetric
}

pred Show {
    #A > 2
}
run Show

assert isAntiSymmetric {
    antisymmetric [A, Test.R]
    //all x, y: A | ((x -> y) in Test.R) and ((y -> x) in Test.R) => (x = y)
}
check isAntiSymmetric
