module Connected

open Inverse
open Complement
open Common

/***************************
          CONNECTED PROPERTY
****************************/

// A relation R in A, is connected if and only if for every
// two distinct elements x and y in A, (x, y) in R or (y, x)
// in R or both.

sig A {}

one sig Test {
    R: A -> A
} {
    R + ~R + (A <: iden) = (A -> A)  // Constrain R to be connected
    // A.R + R.A = A 
    // A.R - R.A = none 
}

pred Show {
    #A > 2
}
run Show

// A relation R in A, is connected if and only if for every
// two distinct elements x and y in A, (x, y) in R or (y, x) 
// in R or both.
assert isConnected {
    connected [A, Test.R]
    // all disj x, y: A | ((x -> y) in Test.R) or ((y -> x) in Test.R)
}
check isConnected
