module Dense

open Inverse
open Complement
open Common

/***************************
                 DENSE RELATION
****************************/

// A relation R in A is dense if for every (x,y),
// x != y, there exists a member z an element of A,
// x != x and y != z, such that (x,z) an element of R
// and (z,y) an element of R. 

abstract sig Letter {}
one sig a extends Letter {}
one sig b extends Letter {}
one sig c extends Letter {}
one sig d extends Letter {}
//one sig e extends Letter {}
//one sig f extends Letter {}

one sig Test {
    R: Letter -> Letter
} 

pred dense (A: univ, R: univ->univ) {
    all disj x, y, z: A | ((x -> y) in R) => ((x -> z) in R) and ((z -> y) in R)
}

pred IncludeEveryLetter {
    Letter in (Test.R[Letter] + Test.R.Letter)
}

pred ConnectEveryLetter {
    connected [Letter, Test.R]
}

fact {
   // IncludeEveryLetter
   // ConnectEveryLetter
}

pred Show { 
    dense [Letter, Test.R]
}
run Show



