module Equivalence

open Inverse
open Complement
open Common

/***************************
       EQUIVALENCE RELATION
****************************/

// An especially important class of relations
// are the equivalence relations. They are 
// reflexive, symmetric, and transitive. 

abstract sig Person {}
one sig Faye extends Person {}
one sig Eleanor extends Person{}
one sig Philip extends Person {}
one sig Roger extends Person {}
one sig Ron extends Person {}

one sig Persons {
    same_haircolor: Person -> Person
} 

pred equivalence (s: univ, r: univ->univ) {
    reflexive [s, r] 
    symmetric [s, r]
    transitive [s, r]
    connected [s, r]
}

pred PartitionPeopleBasedOnHairColor {
    equivalence [Faye+Eleanor+Philip, Persons.same_haircolor]
    equivalence [Roger+Ron, Persons.same_haircolor]
}
run PartitionPeopleBasedOnHairColor

sig elem {}

one sig Test {
    R: elem -> elem
} {
    reflexive [elem, R] 
    symmetric [elem, R]
    transitive [elem, R]
}

pred Show {
    #elem > 2
}
run Show
