module Functional

open Inverse
open Complement
open Common

/***************************
            FUNCTIONAL PROPERTY
****************************/

// A binary relation that maps each atom 
// to at most one other atom is functional 
// and is called a function. 

sig A {}

one sig Test {
    R: A -> A
} {
    #(R.A) = #R  // Constrain R to be functional
}

pred Show {
    #A > 2
}
run Show

assert isFunctional {
    functional [A, Test.R]
    //no disj  x, y, z: A | ((x -> y) in Test.R) and ((x -> z) in Test.R)
}
check isFunctional
