module Injective

open Inverse
open Complement
open Common

/***************************
            INJECTIVE PROPERTY
****************************/

// A binary relation that maps at most one 
// atom to each atom is injective.

sig A {}

one sig Test {
    R: A -> A
} {
    #(A.R) = #R  // Constrain R to be injective
}

pred Show {
    #A > 2
}
run Show

assert isInjective {
    injective [A, Test.R]
    // no disj  x, y, z: A | ((y -> x) in Test.R) and ((z -> x) in Test.R)
}
check isInjective
