module Intransitive

open Inverse
open Complement
open Common

/***************************
        INTRANSITIVE PROPERTY
****************************/

// Given a set A and a relation R in A, if for no 
// pairs (x, y) and (y, z) in R, the pair (x, z) is in R, 
// the relation is intransitive.

sig A {}

one sig Test {
    R: A -> A
} {
    R.R & R = none -> none    // Constrain R to be intransitive
    //R.R not in R  
}

pred Show {
    #A > 2
}
run Show

assert isIntransitive {
    intransitive [A, Test.R]
    // all  x, y, z: A | (((x -> y) in Test.R) and ((y -> z) in Test.R)) => ((x -> z) not in Test.R)
}
check isIntransitive
