module Irreflexive

open Inverse
open Complement
open Common

/***************************
          IRREFLEXIVE PROPERTY
****************************/

// A relation which contains no ordered pair (x, x)
// with identical first and second members is
// called irreflexive.

sig A {}

one sig Test {
    R: A -> A
} {
     (A <: iden) & R = (none -> none)  // Constrain R to be irreflexive
}

pred Show {
    #A > 2
}
run Show

assert isIrreflexive {
    irreflexive [A, Test.R]
    //no x: A | (x -> x) in Test.R
}
check isIrreflexive

// The inverse of an irreflexive relation is irreflexive.
assert inverseIsIrreflexive {
    irreflexive [A, inverse[Test.R]]
}
check inverseIsIrreflexive

// The complement of an irreflexive relation is reflexive.
assert complementIsReflexive {
    reflexive [A, complement[A, Test.R]]
}
check complementIsReflexive
