module Nonconnected

open Inverse
open Complement
open Common

/***************************
            NONCONNECTED PROPERTY
****************************/

// If a relation fails to meet the definition of connected, 
// it is nonconnected. So, there are two distinct elements 
// x and y in A, such that (x, y) and (y, x) are not in R.

sig A {}

one sig Test {
    R: A -> A
} {
    R + ~R + (A <: iden) != (A -> A)  // Constrain R to be non-connected
}

pred Show {
    #A > 2
}
run Show

assert isNonconnected {
    nonconnected [A, Test.R]
   // some disj x, y: A | ((x -> y) not in Test.R) and ((y -> x) not in Test.R)
}
check isNonconnected
