module Nonreflexive

open Inverse
open Complement
open Common

/***************************
       NONREFLEXIVE PROPERTY
****************************/

// A relation which fails to be reflexive is called nonreflexive.

sig A {}

one sig Test {
    R: A -> A
} {
    (A <: iden) & R !=  (A <: iden)  // Constrain R to be non-reflexive
}

pred Show {
    #A > 2
}
run Show

assert isNonReflexive {
    nonreflexive [A, Test.R]
    // some x: A | (x -> x) not in Test.R
}
check isNonReflexive
