module Symmetric

open Inverse
open Complement
open Common

/***************************
     NON-SYMMETRIC PROPERTY
****************************/

// If for some (x, y) in R, the pair (y, x) is
// not in R then R is nonsymmetric.

sig A {}

one sig Test {
    R: A -> A
} {
    ~R not in R  // Constrain R to be non-symmetric
}

pred Show {
    #A > 2
}
run Show

assert isNonsymmetric {
    nonsymmetric  [A, Test.R]
    // some x, y: A | ((x -> y) in Test.R) and ((y -> x) not in Test.R)
}
check isNonsymmetric
