module Ordered

open Common

sig A {}

one sig Ord {
    First: A,
    Next: A -> A
} {
    no x: A | (x -> First) in Next   // First is the first atom in the list
    irreflexive [A, Next]    // Constrain Next to be irreflexive
    intransitive [A, Next]   // Constrain Next to be intransitive 
    asymmetric [A, Next]    // Constrain Next to be asymmetric
    nonconnected [A, Next]    // Constrain Next to be non-connected
    injective [A, Next]   // Constrain Next to be injective
    functional [A, Next]   // Constrain Next to be functional
    #Next = minus[#A, 1]  // Constraint Next to contain all atoms in A
}

fun first: one A { Ord.First }
fun next : A->A { Ord.Next }
fun last: one A { A - (next.A) }

pred Show {
    #A > 2
}
run Show
