module Transitive

open Inverse
open Complement
open Common

/***************************
          TRANSITIVE PROPERTY
****************************/

// Given a set A and a relation R in A, R is transitive
// if and only if for all ordered pairs (x, y) and (y, z) in R,
// the pair (x, z) is also in R.

sig A {}

one sig Test {
    R: A -> A
} {
    R.R in R  // Constrain R to be transitive
}

pred Show {
    #A > 2
}
run Show

assert isTransitive {
    transitive [A, Test.R]
    // all x, y, z: A | (((x -> y) in Test.R) and ((y -> z) in Test.R)) => ((x -> z) in Test.R)
}
check isTransitive
