open util/ordering[Snapshot]

sig Snapshot {
    side1: set Item,
    side2: set Item
}

enum Item { farmer, fox, chicken, grain }

fact init {
    first.side1 = farmer + fox + chicken + grain
    first.side2 = none
}

fact final {
    some s: Snapshot |
            (s.side2 = farmer + fox + chicken + grain) and
            (s.side1 = none)
}

fact not_left_alone_together {
    no s: Snapshot { 
        (farmer in s.side1) and (fox + chicken in s.side2) or
        (farmer in s.side2) and (fox + chicken in s.side1) or
        (farmer in s.side1) and (chicken + grain in s.side2) or
        (farmer in s.side2) and (chicken + grain in s.side1)
    }
}

// In the previous Snapshot the farmer was on side1.
// He moved one Item to side2. So, side1 has one less
// Item and side2 has one more Item.
fact farmer_moves_an_item_to_side_2 {
    all s: Snapshot |
        farmer in s.prev.side1 => 
           some i: s.prev.side1 - farmer | 
               (s.side1 = s.prev.side1 - farmer - i) and
               (s.side2 = s.prev.side2 + farmer + i)
}

// In the previous Snapshot the farmer was on side2.
// He may or may not move one Item to side1. So, 
// side2 has one less Item and side1 has one more Item, or
// side2 has the same Items (sans the farmer) and side1 has 
// the same Items (plus the farmer)
fact farmer_might_move_an_item_to_side_1 {
    all s: Snapshot |
        farmer in s.prev.side2 => 
            some i: s.prev.side2 - farmer | 
                ((s.side2 = s.prev.side2 - farmer - i) and (s.side1 = s.prev.side1 + farmer + i)) or 
                ((s.side2 = s.prev.side2 - farmer) and (s.side1 = s.prev.side1 + farmer))
}

fact fox_chicken_and_grain_remain_on_side2 {
    all s: Snapshot - first |
        (s.prev.side2 = farmer + fox + chicken + grain) =>
            (s.side2 = farmer + fox + chicken + grain) and
            (s.side1 = none)
}

run {} for 8
