open util/ordering[Desktop]

sig Desktop {
    icons: set Icon,
    hidden: set Icon,
    showing: set Icon
} 

sig Icon {}

fact init {
    some i: set Icon | (first.icons = i) and (first.showing = i)
}

fact icons_equals_hidden_plus_showing {
    all d: Desktop | d.icons = d.hidden + d.showing
}

fact Desktops_through_cut_paste_hide_and_show {
    all d: Desktop - first | 
        // cut operation
        (some i: d.prev.showing | (d.icons = d.prev.icons - i) and 
                                                           (d.showing = d.prev.showing - i) and
                                                           (d.hidden = d.prev.hidden))
        or
        // paste operation
        (some i: Icon - d.prev.icons | (d.icons = d.prev.icons + i) and 
                                                                 (d.showing = d.prev.showing + i) and
                                                                 (d.hidden = d.prev.hidden))
        or
        // show operation
        (some i: d.prev.hidden | (d.icons = d.prev.icons) and 
                                                         (d.showing = d.prev.showing + i) and
                                                         (d.hidden = d.prev.hidden - i))
        or
        // hide operation
        (some i: d.prev.showing | (d.icons = d.prev.icons) and 
                                                           (d.showing = d.prev.showing - i) and
                                                           (d.hidden = d.prev.hidden + i))
}

run {} for 5
